try:
	from zcrmsdk.src.com.zoho.crm.api.exception import SDKException
	from zcrmsdk.src.com.zoho.crm.api.util import Constants
except Exception:
	from ..exception import SDKException
	from ..util import Constants


class MultiSelectLookup(object):
	def __init__(self):
		"""Creates an instance of MultiSelectLookup"""

		self.__id = None
		self.__fieldname = None
		self.__has_more = None
		self.__key_modified = dict()

	def get_id(self):
		"""
		The method to get the id

		Returns:
			int: An int representing the id
		"""

		return self.__id

	def set_id(self, id):
		"""
		The method to set the value to id

		Parameters:
			id (int) : An int representing the id
		"""

		if id is not None and not isinstance(id, int):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: id EXPECTED TYPE: int', None, None)
		
		self.__id = id
		self.__key_modified['id'] = 1

	def get_fieldname(self):
		"""
		The method to get the fieldname

		Returns:
			dict: An instance of dict
		"""

		return self.__fieldname

	def set_fieldname(self, fieldname):
		"""
		The method to set the value to fieldname

		Parameters:
			fieldname (dict) : An instance of dict
		"""

		if fieldname is not None and not isinstance(fieldname, dict):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: fieldname EXPECTED TYPE: dict', None, None)
		
		self.__fieldname = fieldname
		self.__key_modified['fieldName'] = 1

	def get_has_more(self):
		"""
		The method to get the has_more

		Returns:
			dict: An instance of dict
		"""

		return self.__has_more

	def set_has_more(self, has_more):
		"""
		The method to set the value to has_more

		Parameters:
			has_more (dict) : An instance of dict
		"""

		if has_more is not None and not isinstance(has_more, dict):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: has_more EXPECTED TYPE: dict', None, None)
		
		self.__has_more = has_more
		self.__key_modified['$has_more'] = 1

	def is_key_modified(self, key):
		"""
		The method to check if the user has modified the given key

		Parameters:
			key (string) : A string representing the key

		Returns:
			int: An int representing the modification
		"""

		if key is not None and not isinstance(key, str):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: key EXPECTED TYPE: str', None, None)
		
		if key in self.__key_modified:
			return self.__key_modified.get(key)
		
		return None

	def set_key_modified(self, key, modification):
		"""
		The method to mark the given key as modified

		Parameters:
			key (string) : A string representing the key
			modification (int) : An int representing the modification
		"""

		if key is not None and not isinstance(key, str):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: key EXPECTED TYPE: str', None, None)
		
		if modification is not None and not isinstance(modification, int):
			raise SDKException(Constants.DATA_TYPE_ERROR, 'KEY: modification EXPECTED TYPE: int', None, None)
		
		self.__key_modified[key] = modification
